summaryrefslogtreecommitdiff
path: root/localedata
diff options
context:
space:
mode:
authorUlrich Drepper <drepper@redhat.com>2000-04-27 05:42:19 +0000
committerUlrich Drepper <drepper@redhat.com>2000-04-27 05:42:19 +0000
commit316518d610789256841f929e3c5757d1e385fcd5 (patch)
treecf53931201515683b375870c359e5ec81ffe6088 /localedata
parentcd201e387c261f9684a76a51e63f194bf49faa3f (diff)
Update.
2000-04-26 Ulrich Drepper <drepper@redhat.com> * iconv/gconv_simple.c (utf8_internal_loop): Correctly reconstruct stored character in state in UNPACK_BYTES macro. * iconv/loop.c (SINGLE(LOOPFCT)): Make it actually work. Correct test for available characters, handle result of BODY code correctly. * localedata/Makefile (test-srcs): Add tst-mbswcs1. (distribute): Add tst-mbswcs.sh. Add rule to run tst-mbswcs.sh. * localedata/tst-mbswcs.sh: New file. * localedata/tst-mbswcs1.c: New file. 2000-04-26 Jakub Jelinek <jakub@redhat.com> * nis/nis_callback.c (__nis_create_callback): Do failed memory allocation fixups centrally, fix __builtin_expect call, return NULL on failure, not NIS_NOMEMORY. 2000-04-27 Bruno Haible <haible@clisp.cons.org>
Diffstat (limited to 'localedata')
-rw-r--r--localedata/Makefile13
-rwxr-xr-xlocaledata/tst-mbswcs.sh51
-rw-r--r--localedata/tst-mbswcs1.c63
3 files changed, 123 insertions, 4 deletions
diff --git a/localedata/Makefile b/localedata/Makefile
index 7e211699a8..f752a7dad8 100644
--- a/localedata/Makefile
+++ b/localedata/Makefile
@@ -35,7 +35,8 @@ locales := $(filter-out $(addprefix locales/, CVS RCS SCCS %~), \
repertoiremaps := $(filter-out $(addprefix repertoiremaps/, CVS RCS SCCS %~), \
$(wildcard repertoiremaps/*))
-test-srcs := collate-test xfrm-test tst-fmon tst-rpmatch tst-trans
+test-srcs := collate-test xfrm-test tst-fmon tst-rpmatch tst-trans \
+ tst-mbswcs1
test-input := de_DE.ISO-8859-1 da_DK.ISO-8859-1 fr_CA,2.13.ISO-8859-1 \
hr_HR.ISO-8859-2 # once it is fixed: cs_CZ.ISO-8859-2
test-input-data = $(addsuffix .in, $(basename $(test-input)))
@@ -56,7 +57,7 @@ distribute := CHECKSUMS README SUPPORTED ChangeLog \
$(charmaps) $(locales) $(repertoiremaps) \
tst-rpmatch.sh tst-locale.sh tst-fmon.sh sort-test.sh \
tst-fmon.data $(test-input-data) $(ld-test-srcs) \
- th_TH.in cs_CZ.in
+ th_TH.in cs_CZ.in tst-mbswcs.sh
# Get $(inst_i18ndir) defined.
include ../Makeconfig
@@ -75,8 +76,10 @@ $(inst_i18ndir)/repertoiremaps/%: repertoiremaps/% $(+force); $(do-install)
ifeq (no,$(cross-compiling))
ifeq (yes,$(build-shared))
-.PHONY: do-collate-test do-tst-fmon do-tst-locale do-tst-rpmatch do-tst-trans
-tests: do-collate-test do-tst-fmon do-tst-locale do-tst-rpmatch do-tst-trans
+.PHONY: do-collate-test do-tst-fmon do-tst-locale do-tst-rpmatch do-tst-trans \
+ do-tst-mbswcs
+tests: do-collate-test do-tst-fmon do-tst-locale do-tst-rpmatch do-tst-trans \
+ do-tst-mbswcs
do-collate-test: sort-test.sh $(objpfx)collate-test $(objpfx)xfrm-test \
$(test-input-data)
$(SHELL) -e $< $(common-objpfx) $(test-input)
@@ -88,6 +91,8 @@ do-tst-rpmatch: tst-rpmatch.sh $(objpfx)tst-rpmatch do-tst-fmon
$(SHELL) -e $< $(common-objpfx)
do-tst-trans: tst-trans.sh $(objpfx)tst-trans
$(SHELL) -e $< $(common-objpfx)
+do-tst-mbswcs: tst-mbswcs.sh $(objpfx)tst-mbswcs1
+ $(SHELL) -e $< $(common-objpfx)
endif
endif
diff --git a/localedata/tst-mbswcs.sh b/localedata/tst-mbswcs.sh
new file mode 100755
index 0000000000..c9a1600513
--- /dev/null
+++ b/localedata/tst-mbswcs.sh
@@ -0,0 +1,51 @@
+#! /bin/sh
+# Testing the implementation of the mb*towc*() and wc*tomb*() functions.
+# Copyright (C) 2000 Free Software Foundation, Inc.
+# This file is part of the GNU C Library.
+#
+# The GNU C Library is free software; you can redistribute it and/or
+# modify it under the terms of the GNU Library General Public License as
+# published by the Free Software Foundation; either version 2 of the
+# License, or (at your option) any later version.
+#
+# The GNU C Library is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+# Library General Public License for more details.
+#
+# You should have received a copy of the GNU Library General Public
+# License along with the GNU C Library; see the file COPYING.LIB. If
+# not, write to the Free Software Foundation, Inc.,
+# 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+
+common_objpfx=$1; shift
+
+generate_locale ()
+{
+ charmap=$1
+ input=$2
+ out=$3
+ rep=$4
+ I18NPATH=. \
+ ${common_objpfx}elf/ld.so --library-path $common_objpfx \
+ ${common_objpfx}locale/localedef --quiet -c -f $charmap -i $input \
+ --repertoire-map $rep ${common_objpfx}localedata/$out
+
+ if [ $? -ne 0 ]; then
+ echo "Charmap: \"${charmap}\" Inputfile: \"${input}\"" \
+ "Outputdir: \"${out}\" failed"
+ exit 1
+ fi
+}
+
+generate_locale UTF8 de_DE de_DE.UTF-8 mnemonic.ds
+
+status=0
+
+# Run the test programs.
+LOCPATH=${common_objpfx}localedata GCONV_PATH=${common_objpfx}iconvdata \
+${common_objpfx}elf/ld.so --library-path $common_objpfx \
+ ${common_objpfx}localedata/tst-mbswcs1 \
+ > ${common_objpfx}localedata/tst-mbswcs.out || status=1
+
+exit $status
diff --git a/localedata/tst-mbswcs1.c b/localedata/tst-mbswcs1.c
new file mode 100644
index 0000000000..79745f021a
--- /dev/null
+++ b/localedata/tst-mbswcs1.c
@@ -0,0 +1,63 @@
+/* Test restarting behaviour of mbrtowc.
+ Copyright (C) 2000 Free Software Foundation, Inc.
+ This file is part of the GNU C Library.
+ Contributed by Bruno Haible <haible@ilog.fr>.
+
+ The GNU C Library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public License as
+ published by the Free Software Foundation; either version 2 of the
+ License, or (at your option) any later version.
+
+ The GNU C Library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ Library General Public License for more details.
+
+ You should have received a copy of the GNU Library General Public
+ License along with the GNU C Library; see the file COPYING.LIB. If not,
+ write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+ Boston, MA 02111-1307, USA. */
+
+#include <stdio.h>
+#include <string.h>
+#include <wchar.h>
+#include <locale.h>
+
+#define show(expr, nexp, wcexp) \
+ n = expr; \
+ printf (#expr " -> %Zd", n); \
+ printf (", wc = %lu", (unsigned long int) wc); \
+ if (n != (size_t) nexp || wc != wcexp) \
+ { \
+ printf (", expected %Zd and %lu", nexp, (unsigned long int) wcexp); \
+ result = 1; \
+ } \
+ putc ('\n', stdout)
+
+int
+main (void)
+{
+ unsigned char buf[6] = { 0x25, 0xe2, 0x82, 0xac, 0xce, 0xbb };
+ mbstate_t state;
+ wchar_t wc = 42;
+ size_t n;
+ int result = 0;
+ const char *used_locale;
+
+ setlocale (LC_CTYPE, "de_DE.UTF-8");
+ /* Double check. */
+ used_locale = setlocale (LC_CTYPE, NULL);
+ printf ("used locale: \"%s\"\n", used_locale);
+ result = strcmp (used_locale, "de_DE.UTF-8");
+
+ memset (&state, '\0', sizeof (state));
+
+ show (mbrtowc (&wc, buf + 0, 1, &state), 1, 37);
+ show (mbrtowc (&wc, buf + 1, 1, &state), -2, 37);
+ show (mbrtowc (&wc, buf + 2, 3, &state), 2, 8364);
+ show (mbrtowc (&wc, buf + 4, 1, &state), -2, 8364);
+ show (mbrtowc (&wc, buf + 5, 1, &state), 1, 955);
+ show (mbrtowc (&wc, buf + 5, 1, &state), -1, 955);
+
+ return result;
+}